	PROGRAM OUTLIER

c*******within-family outliers are identified

	PARAMETER (ND=30000)
	PARAMETER (NPAR=35000)

	dimension mas(ND,5),tra(ND),luk(ND),nom(NPAR,2)
	dimension np_sib(NPAR,5),tr_sib(NPAR,2),d2_sib(NPAR)

	character*20 pedfl
	character*13 trname

	character*6 gender(2)
	character*6 parent(2)
	DATA parent /'father','mother'/
	DATA gender /'male','female'/

	open (unit=10,file='outlier.out',status='REPLACE')
	write(10,*)'ERROR: cannot open or read pedigree file'
        write(10,*)'Press "Ctrl O" to see system information  '
	close (unit=10)

C	READING PEDIGREE FILE AND TRAIT
	print 101
	read*,pedfl
101	format('INPUT NAME of FILE WITH PEDIGREE DATA: ',$)

	open (unit=1,file=pedfl,status='old')

	print 102
102	format('INPUT CODE OF MISSING DATA (REAL OR INTEGER)'/  
     *	   '      OR "NO" FOR SAMPLE WITHOUT MISSING DATA: ',$)
	read(*,*,iostat=ios) val
	if(ios/=0)then
	val=999999.
	end if

	read (1,*)trname,trname,trname,trname,trname,trname
	i=0
	xt=0.
	xxt=0.
	tmin=9999.
	tmax=-9999.
	nizm=0
311	i=i+1
	read (1,*,end=312)(mas(i,j),j=1,5),tra(i)
	if (tra(i).ne.val)then
	xt=xt+tra(i)
	xxt=xxt+tra(i)*tra(i)
	if (tra(i)>tmax)tmax=tra(i)
	if (tra(i)<tmin)tmin=tra(i)
	nizm=nizm+1
	end if
	goto 311
312	close (unit=1)
	ndat=i-1
        if (ndat.gt.ND)
     *    stop 'Increase parameter ND and recompile !'
	gt=nizm
	pop_mean=xt/gt
	dis_all=(xxt-xt*xt/gt)/(gt-1)
c	print *,nizm,pop_mean,dis_all
c	pause

	open (unit=10,file='outlier.out',status='REPLACE')

	write(10,*)'INPUT FILE: ',pedfl
	if(val==999999.)then
	write(10,*)'MISSING VALUE: no'
	else
	write(10,*)'MISSING VALUE:',val
	end if
	write(10,*)

C	**********ERRORS TESTING***************************
	ierr=0
	do 1 i1=1,ndat-1
	iper=mas(i1,2)
	isex=mas(i1,5)

C	TESTING SEX ERRORS
	if(isex/=1.and.isex/=2)then
	write(10,'(a,i6,a,i2)')'Sex error: Person ',iper,
     *' has incorrect sex code ',isex
	ierr=ierr+1
	goto 7
	end if

	do 11 i2=1,ndat
	if(mas(i2,1)/=mas(i1,1))goto 11
	do j=3,4
	if(iper==mas(i2,j).and.isex+2/=j)then
	write(10,120)iper,gender(isex),parent(j-2),i2
120	format('Sex error: Person',i6,' is ',a6,', but ',a6,
     *' in line',i6)
	ierr=ierr+1
	end if
	end do
11    end do

C	TESTING DUPLICATIONS
7	do 12 i2=i1+1,ndat
	if(mas(i2,1)/=mas(i1,1))goto 12
	if(iper==mas(i2,2))then
	write(10,'(3(a,i6))')'Person ',iper,' was duplicated in lines:'
     *	,i1,' and',i2
	ierr=ierr+1
	end if
12    end do

1     end do

	if(ierr/=0)then
	print*
	print*,'THERE ARE ERRORS IN PEDIGREE STRUCTURE. '
	pause 'PROGRAM IS STOPED. SEE DETAILS IN FILE outlier.out'
	print*
      stop	
	end if
C	********************END TESTING ******************************
	x=0.
	xx=0.
	xy=0.
	np=0


	do 2 i=1,NDAT-1

	if(mas(i,3)==0)goto 2
	if(tra(i)==val)goto 2
	ifa=mas(i,3)
	imo=mas(i,4)

	do 3 j=i+1,NDAT

	if(mas(j,1)/=mas(i,1)) goto 2
	if(tra(j)==val)goto 3
	

	if(mas(j,3)==ifa.and.mas(j,4)==imo)then
	np=np+1
		
	x=x+tra(i)+tra(j)
	xx=xx+tra(i)*tra(i)+tra(j)*tra(j)
	xy=xy+tra(i)*tra(j)
	
	t=tra(i)-tra(j)
	d2_sib(np)=t*t

	np_sib(np,1)=mas(i,1)
	np_sib(np,2)=ifa
	np_sib(np,3)=imo
	np_sib(np,4)=mas(i,2)
	np_sib(np,5)=mas(j,2)

	tr_sib(np,1)=tra(i)
	tr_sib(np,2)=tra(j)

     	end if

3	continue
2	continue
        if (np.gt.NPAR)
     *    stop 'Increase parameter NPAR and recompile !'

C	Statistics
	
C	EXPECTED
	q=np*2.
	disX=q*xx-x*x
	disXY=q*xy*2.-x*x
	ro=disXY/disX

	exp_mean=2.*(1.-ro)*dis_all
	exp_sd=sqrt(2.)*exp_mean
	D2_max=exp_mean+4.*exp_sd

C	REMOVAL OUTLIERS
	nout=0

	do 5 i=1,np

	if(d2_sib(i) > D2_max)then
	ks=1
	do 6 j=1,np
	if(j==i)goto 6
	if(np_sib(j,1)/=np_sib(i,1))goto 6
	if(np_sib(j,2)==np_sib(i,2).and.np_sib(j,3)==np_sib(i,3))
     *  ks=ks+1
6	end do
	if(ks==1)then
C	removing both sibs
	luk1=0
	luk2=0
	if(nout==0)goto 8
	do ii=1,nout
	if(nom(ii,1)==np_sib(i,1).and.nom(ii,2)==np_sib(i,4))luk1=1
	if(nom(ii,1)==np_sib(i,1).and.nom(ii,2)==np_sib(i,5))luk2=1
	end do
8	if(luk1==0)then
	nout=nout+1
	nom(nout,1)=np_sib(i,1)
	nom(nout,2)=np_sib(i,4)
	end if
	if(luk2==0)then
	nout=nout+1
	nom(nout,1)=np_sib(i,1)
	nom(nout,2)=np_sib(i,5)
	end if
	else if(ks>1) then
C	removing one sib
	r1=abs(tr_sib(i,1)-pop_mean)
	r2=abs(tr_sib(i,2)-pop_mean)
	L=1
	if(r1 < r2)L=2
	luk1=0
	if(nout==0)goto 9

	do ii=1,nout
	if(nom(ii,1)==np_sib(i,1).and.nom(ii,2)==np_sib(i,L+3))luk1=1
	end do
9	if(luk1==0)then
	nout=nout+1
	nom(nout,1)=np_sib(i,1)
	nom(nout,2)=np_sib(i,L+3)
	end if
	end if
	end if
5	end do

	if(nout/=0)then
	write(10,*)
     *	'INDIVIDUAL(s) IDENTIFIED AS WITHIN-FAMILY OUTLIER(s):'
	do i=1,nout
	write(10,'(i5,i8)')(nom(i,j),j=1,2)
	end do
	write(10,*)
	write(10,*)'=================================================='
	else
	write(10,*)'WITHIN-FAMILY OUTLIERS DID NOT FOUND'
	write(10,*)
	write(10,*)'=================================================='
	end if


	write(10,*)
	write(10,*)'QUANTITATIVE TRAIT STATISTICS'
       write(10,'(13x,a8,5(a15))')'N','Min ','Max ','Mean ','Var  ',
     * 'SibCorr'
	write(10,'(a13,i8,5(f13.4,2x))')trname,nizm,tmin,tmax,
     *pop_mean,dis_all,ro
	write(10,*)

	write(10,*)
     *'EXPECTED PARAMETERS OF SQUARED DIFFERENCE DISTRIBUTION:'
	write(10,'(a14,E11.4,a13)')'E(D2)        =',exp_mean
	write(10,'(a14,E11.4,a11)')'SD(D2)       =',exp_sd
	write(10,'(a14,E11.4,a11)')'E(D2)+4SD(D2)=',D2_max
	write(10,*)

C	WRITING SIB PAIRS IN OUTPUT FILE
       write(10,'(5a8,2a12,a11)')'fam','fa  ','mo  ','id_1 ','id_2 ',
     * 'tr_1  ','tr_2  ','D2   '  
     	do i=1,np
	write (10,'(5i8,2e12.4,e11.4)')(np_sib(i,j),j=1,5),
     *	(tr_sib(i,j),j=1,2),d2_sib(i)
	end do

	close(unit=10)

	print*
	pause 'PROGRAM IS FINISHED. SEE RESULTS IN FILE outlier.out '

	stop
	end

